
From: Alan Cox <alan@lxorguk.ukuu.org.uk>

This got missed originally as it is marked BROKEN_ON_SMP (I can't see why
however).  Updated and compile tested.  I don't have hardware

Signed-off-by: Alan Cox <alan@redhat.com>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 drivers/usb/serial/whiteheat.c |   11 +++++------
 1 files changed, 5 insertions(+), 6 deletions(-)

diff -puN drivers/usb/serial/whiteheat.c~tty-layer-buffering-revamp-usb-white-heat-fix drivers/usb/serial/whiteheat.c
--- devel/drivers/usb/serial/whiteheat.c~tty-layer-buffering-revamp-usb-white-heat-fix	2005-09-06 17:54:26.000000000 -0700
+++ devel-akpm/drivers/usb/serial/whiteheat.c	2005-09-06 17:54:26.000000000 -0700
@@ -1430,7 +1430,9 @@ static void rx_data_softint(void *privat
 		urb = wrap->urb;
 
 		if (tty && urb->actual_length) {
-			if (urb->actual_length > TTY_FLIPBUF_SIZE - tty->flip.count) {
+			int len = tty_buffer_request_room(tty, urb->actual_length);
+			/* This stuff can go away now I suspect */
+			if (unlikely(len < urb->actual_length)) {
 				spin_lock_irqsave(&info->lock, flags);
 				list_add(tmp, &info->rx_urb_q);
 				spin_unlock_irqrestore(&info->lock, flags);
@@ -1438,11 +1440,8 @@ static void rx_data_softint(void *privat
 				schedule_work(&info->rx_work);
 				return;
 			}
-
-			memcpy(tty->flip.char_buf_ptr, urb->transfer_buffer, urb->actual_length);
-			tty->flip.char_buf_ptr += urb->actual_length;
-			tty->flip.count += urb->actual_length;
-			sent += urb->actual_length;
+			tty_insert_flip_string(tty, urb->transfer_buffer, len);
+			sent += len;
 		}
 
 		urb->dev = port->serial->dev;
_
